:
pics=${1:-/pics}

. /etc/rc_d/ask.sh


Exists() {
        [ -f $1 ]
}

grab_subs() {
        dir=$1
        file=$2
        shift 2
        for sub in $*
	do
                [ -d $dir/$sub ] || continue
                find $dir/$sub -name "$file" -print
	done | sed "s,$dir/\(.*\)/[^/]*\$,& \1," | while read src dest
        do
                [ -d $dest ] || mkdir -p $dest
                if [ -d $dest ]; then
                        $ECHO ln -sf $src $dest
		fi
        done
}

grab_raw() {
        dir=$1
        file=$2
        if [ -d $dir/raw ]; then
                if [ -s $dir/raw/$file ]; then
                        [ -d raw ] || $ECHO mkdir -p raw
                        [ -s raw/$file ] || $ECHO ln -sf $dir/raw/$file raw
                        exif1=`echo $file | sed 's,\.[^\.]*$,.exif1,'`
                        if [ -s $dir/raw/$exif1 ]; then
                                [ -s raw/$exif1 ] || $ECHO ln -sf $dir/raw/$exif1 raw
			fi
		fi
	fi
}

grab1() {
        if Exists $*; then
                echo "Grabbing $1 ..."
                for f in $*
		do
                        case $f in
			*.htm*) ;;
			*.bak|*.old|*~) ;;
			*)
                                file=`basename $f`
                                [ -s $file ] || $ECHO ln -sf $f .
                                #grab_raw `dirname $f` $file
                                grab_subs `dirname $f` $file raw print
                                ;;
			esac
		done
                :
	else
                false
	fi
}

grab() {
        day=${2:-$day}
        month=${3:-$month}
        year=${4:-$year}

        grab1 $1* ||
        grab1 $pics/$1* ||
        grab1 $pics/$year$month$day$1* ||
        grab1 $pics/$year/$month/$year$month$day$1* ||
        grab1 $pics/$year/$month/$day/$year$month$day$1*
}

while :
do
        case "$1" in
	*=*) eval "$1"; shift;;
	--) shift; break;;
	*) break;;
	esac
done

if [ -t 0 ]; then
        cat <<!EOM
This tool helps you grab pics for a collection.
You specify YYYY mm dd NN[N] to grab YYYYmmddNN*
to grab pics from the next day you need only specify dd and NN.
!EOM

	while :
        do
                ask p "Grab? [[[YYYY] [mm]] [dd]] NN[N]"
                case "${p:-q}" in
		q*) exit 0;;
		esac
                set -- $p
                grab $4 $3 $2 $1
	done
else
        echo "Grabbing bulk... expect YYYY mm dd NN[N]"
        while read YYYY mm dd NN
	do
                case $YYYY in
		*/*.*)
                	it=`echo $YYYY | sed 's,\.[^.]*$,,'`
                        grab $it && continue
                	eval `basename $YYYY$mm$dd$NN | sed 's,^\(....\)\(..\)\(..\)\(..[0-9]*\).*,YYYY=\1 mm=\2 dd=\3 NN=\4,'`
                        ;;
		??????*)
                        eval `echo $YYYY$mm$dd$NN | sed 's,^\(....\)\(..\)\(..\)\(..[0-9]*\).*,YYYY=\1 mm=\2 dd=\3 NN=\4,'`;;
		esac
                grab $NN $dd $mm $YYYY
	done
fi

